package be.jeffcheasey88.peeratcode.parser;

import java.io.BufferedReader;

import be.jeffcheasey88.peeratcode.parser.state.StateTree;

public class Parser<E>{

	private Tokenizer tokenizer;
	private StateTree<E> state;
	
	public Parser(){}
	
	public void setTokenizer(Tokenizer tokenizer){
		this.tokenizer = tokenizer;
	}
	
	public void setStateTree(StateTree<E> stateTree){
		this.state = stateTree;
	}
	
	public final void parse(BufferedReader reader, E container) throws Exception{
		this.tokenizer.parse(reader);
		
		this.state.seed(this.tokenizer, container);
	}
}
